if(!Object.create) {　　　　
	Object.create = function(o) {　　　　　　
		function F() {}　　　　　　
		F.prototype = o;　　　　　　
		return new F();　　　　
	};
}


var Application = {
	createNew: function($, page) {　　　　　　
		var app = {
			https: false,
			host: 'cph.buy23.cn',
			appName: '南昌公寓',
			$: $,
			page: page,
			/**
			 * 初始化
			 */
			init: function(){
				if('function' == typeof(page.init)){
					page.init();
				}
			},
			/**
			 * ubb转HTML
			 * @param {Object} val
			 */
			ubb2Html: function (val)
			{
				val = val.replace(/\n/ig, "<br>");
			    val = val.replace(/\[img]([^\[\]]*)\[\/img\]/ig, "<img src=\"$1\"/>");
			    val = val.replace(/\[b\]([^\[\]]*)\[\/b\]/ig, "<b>$1</b>");
			    val = val.replace(/\[strong\]([^\[\]]*)\[\/strong\]/ig, "<strong>$1</strong>");
			    val = val.replace(/\[i\]([^\[\]]*)\[\/i\]/ig, "<i>$1</i>");
			//  val = val.replace(/\[a href=\"?([^ \'\"\[\]]*)\"?\]([^\[\]]*)\[\/a\]/ig, "<a href=\"$1\" target=\"_blank\">$2</a>");
			    return val;
			},
			/**
			 * html转ubb
			 * @param {Object} val
			 */
			html2Ubb: function (val)
			{
				val = val.replace(/<(\/?)br>/ig, "\r\n");
			    val = val.replace(/\< *img (.+ )*src=["|']?([^ ="']*)["|']?( .+)*\/?\>/ig, "[img]$2[/img]");  // img
			    val = val.replace(/<(\/?)b>/ig, "[$1b]");                                                     // b
			    val = val.replace(/<(\/?)strong>/ig, "[$1strong]");                                           // strong
			    val = val.replace(/<(\/?)i>/ig, "[$1i]");                                                     // i
			//  val = val.replace(/<a (.+ )*href=\"?([^ \"\']*)\"?( .+)*>([^<>]*)< *\/a *>/ig, "[a href=\"$2\"]$4[/a]");// a
			    return val;
			},
			/**
			 * 判断是否被数组包含
			 * @param {Object} search
			 * @param {Object} array
			 */
			in_array: function (search,array){
			    for(var i in array){
			        if(array[i]==search){
			            return true;
			        }
			    }
			    return false;
			},
			/**
			 * 将模板套上对应的数据形成HTML
			 */
			template: function(templateId, data){
				var self = this
				var reg = new RegExp("\\[([^\\[\\]]*?)\\]", 'igm'); 
				
				var template = document.getElementById(templateId);
				var html = template.innerHTML;
				var source = '';
				this.$.each(data, function(i, obj){
					source += html.replace(reg, function (node, key) {
						if('object' == typeof(obj[key])){
							return JSON.stringify(obj[key])
						}
						if(self.in_array(key, [
							'img', 'logo', 'image','cover'
						])){
							if(null == obj[key]){
								return '';
							}else if(obj[key].indexOf('../') >= 0){
								return obj[key];
							}else if(obj[key].indexOf('http://') >= 0){
								return obj[key];
							}else if(obj[key].indexOf('https://') >= 0){
								return obj[key];
							}else{
								return (self.https?'https://':'http://') + self.host + obj[key];	
							}
						}
						return (obj[key] == undefined || obj[key] === false || obj[key] === null)?'':obj[key]; 
					})
				})
			
				return source;
			},
			getImgUrl : function (url) {
				var self = this
				console.log(JSON.stringify(url));
				if(/^http/.test(url)){
					return url
				}
				
				return (self.https?'https://':'http://') + self.host + url;
			}
		};　　　　

		return app;　　　　
	}
}