if(!Object.create) {　　　　
	Object.create = function(o) {　　　　　　
		function F() {}　　　　　　
		F.prototype = o;　　　　　　
		return new F();　　　　
	};
}

var MyPlus = {
	https: false,
	host: 'cph.buy23.cn/myapi',
	$: mui,
	/**
	 * 自动消失的提示框
	 * @param {Object} msg
	 */
	toast: function(msg){
		this.$.toast(msg);
	},
	initPage: function(callback){
		var self = this
		window.addEventListener('initPage', function(event){
			console.log('initPage')
			var curWV = plus.webview.currentWebview();
			callback(event.detail)
			console.log('initPage End')
		})
		self.$.plusReady(function(){
			var curWV = plus.webview.currentWebview();

			callback(curWV);
			console.log('plusReady End')
		})
	},
	/**
	 * 跳转页面
	 * @param {Object} url
	 * @param {Object} params
	 */
	goTo: function(url, params){
		if(!params) params = {}
		var id = url.replace('../', '');
		
//		if(id == 'index.html'){
//			id = 'HBuilder';
//		}
		var vNextPage = null;	
	    //获得下一个页面
	    if (vNextPage == null) {
	        vNextPage = plus.webview.getWebviewById(id);//这个是下一个页面的ID，第一次，他肯定为空，所以，这里面这个fire方法，是不会执行的。
	        if (vNextPage != null) {
	            //触发下一个页面的自定义事件
	            mui.fire(vNextPage, 'initPage', params);
	        }
	    }
		
		this.$.openWindow({
			url: url,
			id: id,
			extras: params,
			show: {
				autoShow: true,
				aniShow: 'pop-in',
				event:'loaded'
			},
			styles: {
				popGesture: 'hide'
			},
			waiting: {
				autoShow: false,//自动显示等待框，默认为true
      			title:'正在加载...'//等待对话框上显示的提示内容
			}
		});
	},
	geoLocation: function(callback, option){
		var self = this
		plus.geolocation.getCurrentPosition(function(position){
			callback(position)
		}, function(error){
			// Handle error
//			var code = error.code; // 错误编码
//			var message = error.message; // 错误描述信息
			console.log(error.code + ' ' + error.message)
			self.$.toast(error.code + ' ' + error.message)
		}, option);
	},
	/**
	 * 拍照或选取照片
	 * @param callable callback
	 */
	getImg: function(title, callback){
		if('function' == typeof title){
			callback = title;
			title="修改用户头像";
		}
		
		var self = this
		if (mui.os.plus) {
	        var a = [{ 
	            title: "拍照" 
	        }, { 
	            title: "从手机相册选择" 
	        }]; 
	        plus.nativeUI.actionSheet({ 
	            title: title, 
	            cancel: "取消", 
	            buttons: a 
	        }, function(b) { /*actionSheet 按钮点击事件*/ 
	            switch (b.index) { 
	                case 0: 
	                    break; 
	                case 1: 
	                	console.log('正在调用摄像头')
	                    self.takePhoto(callback); /*拍照*/ 
	                    break; 
	                case 2: 
	                	console.log('正在打开相册')
	                    self.galleryImg(callback);/*打开相册*/ 
	                    break; 
	                default: 
	                    break; 
	            } 
	        }) 
	    } 
	},
	
	/**
	 * 调取摄像头拍照
	 * @param callable callback
	 */
	takePhoto: function (callback){
		var self = this
		var camera = plus.camera.getCamera(); 
	    camera.captureImage(function(capturedFile) { 
	    	console.log(capturedFile)
	    	self.compressImage(capturedFile, callback)
	    }, function(error) {
	        console.log(error.code + ' ' + error.message)
	    }, { 
	        filename: "_doc/camera/" 
	    }) 
	},
	
	/**
	 * 从相册选取照片
	 * @param callable callback
	 */
 	galleryImg: function (callback) {
 		var self = this
	 	// 从相册选取一张图片
	    plus.gallery.pick( function(image){
	    	console.log(image)
	    	//根据文件地址，返回一个文件或目录操作对象
	        plus.io.resolveLocalFileSystemURL(image, function(entry) {
	            plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
	            	var selectFileName = entry.name;
	            	var file_ext='.'+selectFileName.replace(/.+\./,"");
	            	var selectZipFileName = selectFileName.replace(file_ext, '_zip'+file_ext)
	            	console.log(selectFileName)
	            	root.getFile(selectZipFileName, {}, function(file) { 
	                    var path = file.fullPath + "?version=" + new Date().getTime(); 
                        callback(path);
	                }, function(error) {
	                	console.log(error.code + ' ' + error.message)
	                	root.getFile(selectFileName, {}, function(file) { 
		                    //文件已存在 
		                    var path = file.fullPath; 
		                    path = plus.io.convertAbsoluteFileSystem(path);
		                    console.log(path)
		                    self.compressImage(path, callback)
		                }, function() { 
		                    //文件不存在 
		                    entry.copyTo(root, selectFileName, function(dst) { 
	                            var path = dst.fullPath; 
	                            path = plus.io.convertAbsoluteFileSystem(path);
	                            self.compressImage(path, callback)
	                        }, 
	                        function(error) { 
	                            console.log(error.code + ' ' + error.message)
	                        }); 
		                }); 
	                });
	            }, function(error) { 
	                console.log(error.code + ' ' + error.message)
	            }) 
	        }, function(error) { 
	        	//读取文件或目录操作对象失败
	            console.log(error.code + ' ' + error.message)
	        }); 
	    }, function ( error ) {
	    	console.log(error.code + ' ' + error.message)
	    }, {filter:"image"} );
	},
	
	/**
	 * 压缩图片
	 */
	compressImage: function (img, callback){
		var self = this;
		console.log(img)
		var file_name=img.replace(/(.*\/)*([^.]+).*/ig,"$2");
		var file_ext=img.replace(/.+\./,"");
		var option = {
			src:img,
			dst:'_doc/' + file_name + '_zip.' + file_ext,
			quality:20
		}
		console.log(JSON.stringify(option))
		plus.zip.compressImage(option,
			function(event) {
				console.log(JSON.stringify(event))
				var imageFile = event.target + "?version=" + new Date().getTime()
				callback(imageFile)
			},function(error) {
				console.log(error.code + ' ' + error.message)
		});
	},
	/**
	 * 文件上传
	 * @param {Object} serverUrl
	 * @param {Object} imgUrl
	 * @param {Object} name
	 * @param {Object} success
	 * @param {Object} error
	 */
	upload: function (serverUrl, imgUrl, name, success, error){
		var self = this
	    if(typeof name == 'function'){
	    	error = success
	    	success = name;
	    	name = undefined;
	    }
	    
	    name = name ||"image";
	    if(!/^file\:\/\/\//.test(imgUrl)){
	    	imgUrl = "file:///"+imgUrl
	    }
	    var wt=plus.nativeUI.showWaiting();
	    var task=plus.uploader.createUpload((self.https?'https://':'http://')+self.host+serverUrl,
			{method:"POST"},
	        function(t,status){ //上传完成
	            if(status==200){
					var data = JSON.parse(t.responseText);
					if(data.code){
						if(typeof success == "function"){
							success(data.data);
						} 
					} else {
						self.toast('上传失败：'+data.msg);
						console.log(JSON.stringify(data));
						if(typeof error == 'function'){
							error(data.msg);
						}
					}
	                wt.close(); //关闭等待提示按钮
	            }else{
	            	console.log(JSON.stringify(t));
	                self.toast("上传失败："+status,'上传失败');
	                wt.close();//关闭等待提示按钮
	            }
	        }
	    );
	    //添加其他参数
	    task.addFile(imgUrl,{key:name, token:getData('token')});
	    task.start();
	},
	/**
	 * 多图上传
	 * @param {Object} serverUrl
	 * @param {Object} imgList
	 */
	multipleUpload: function (serverUrl, imgList, success, error){
		console.log(JSON.stringify(imgList))
		var self = this
		var wt=plus.nativeUI.showWaiting();
	    var task=plus.uploader.createUpload((self.https?'https://':'http://')+self.host+serverUrl,
			{method:"POST"},
	        function(upload,status){ //上传完成
	        	console.log(JSON.stringify(upload))
	        	console.log(status)
	            if(status==200){
	            	console.log(upload.responseText)
					var data = JSON.parse(upload.responseText);
					console.log(upload.responseText)
					if(data.RETURN == "SUCCESS"){
						if(typeof(success) == "function"){
							success(data.DATA);
						} 
					} else {
						self.toast('上传失败：'+data.ERROR.errMsg, '上传失败');
						if(typeof(error) == 'function'){
							error(data.ERROR);
						}
					}
	                wt.close(); //关闭等待提示按钮
	            }else{
	                self.toast("上传失败："+status,'上传失败');
//		                if(typeof(obj.error) == 'function'){
//							obj.error();
//						}
	                wt.close();//关闭等待提示按钮
	            }
	        }
	    );
		self.$.each(imgList, function(i, obj){
			console.log(JSON.stringify(obj))
			var name = obj.name;
			var imgUrl = obj.url;
		    if(!/^file\:\/\/\//.test(imgUrl)){
		    	imgUrl = "file:///"+imgUrl
		    }
		    console.log(JSON.stringify(obj));
		    //添加其他参数
	    	task.addFile(imgUrl,{key:name});
		})
	    
	    task.start();
	},
	/**
	 * ajax 网络请求
	 * @param {Object} path
	 * @param {Object} options
	 */
	ajax: function (path, options){
		var self = this
		if('object' != typeof(options)){
			options = {};
		}
		if('function' != typeof(options.success)){
			options.success = function(res){
				console.log(res)
			}
		}
		if('function' != typeof(options.error)){
			options.error = function(xhr,type,errorThrown){
				console.log(errorThrown)
				self.toast(errorThrown)
			}
		}
		if(!options.url){
			options['url'] = (self.https?'https://':'http://') + self.host + path
		}
		if(options.async === undefined){
			options.async = true;
		}
		if(!options.timeout){
			options.timeout = 100000;
		}
		if(!options.data){
			options.data = {};
		}
		
		var headers = {
			'Content-Type' : 'application/json',
			'deviceType' : 'APP'
		}
		if('object' == typeof(options.headers)){
			//将传入的header头合并或替换
			self.$.each(options.headers,function (key,obj) {
				headers[key] = obj;
			})
		}
		//如果有则附加访问token
		var token = plus.storage.getItem("token");
		if(token){
			headers['token'] = token;
		}
		options.data['sign'] = this.sign(options.data, plus.device.uuid, token)
		console.log('开始请求：'+options.url);
		console.log(JSON.stringify(options))
		var settings = {
			data:options.data,
			dataType:'json',
			type:'post',
			timeout:options.timeout,
			headers:headers,
			success:function(res){
				console.log(JSON.stringify(res))
				switch(res.RETURN){
					case 'SUCCESS':
						if('function' == typeof(options.success)){
							options.success(res.DATA);
						}
						break;
					case 'FAIL':
						console.log(typeof(options.fail))
						if('function' == typeof(options.fail)){
							options.fail(res.ERROR);
						} else {
							self.toast(res.ERROR.errMsg);
						}
						break;
					default:
						self.toast('未知错误，请联系系统管理员')
						break;
				}
			},
			error:function(xhr,type,errorThrown){
				console.log('bbbbbbbbbbbbbbbbbbbbbbbbbbbbb');
				console.log(xhr.responseText);
				console.log(type);
				console.log(errorThrown);
				self.$.toast(errorThrown)
				if("" == xhr.responseText){
					self.$.toast('请求失败')
				}
//				options.fail(errorThrown)
			}
		}
		
		console.log(JSON.stringify(settings))
		
		self.$.ajax(options.url, settings)
	},

	getOtherScript : function(path, callback){
		var self = this;
		path = (self.https?'https://':'http://') + self.host + path;
		self.$.ajax(path, {
			'dataType' : 'script',
			'type' : 'get',
			'success' : callback
		})
	},

	sign: function (data, device, token){
		var keyName = [];
		for(var i in data){
			keyName.push(i);
		}
		keyName.sort();
		var tmpString = '';
	
		for(var i in keyName){
			if(tmpString.length == 0){
				tmpString = keyName[i]+'='+data[keyName[i]];
			}else {
				tmpString =tmpString + '&'+keyName[i]+'='+data[keyName[i]]
			}
		}
		tmpString =tmpString + '&device='+hex_md5(device)+'&token='+token
		return(hex_md5(tmpString));
	},
	
	geocode : function(address, city, success, error){
		plus.maps.Map.geocode(address, {
			'coordType' : 'bd09',
			'city' : city
		}, success, error)
	},
	bd09togcj02 : function(bd_lon, bd_lat) {
		var x_PI = 3.14159265358979324 * 3000.0 / 180.0;
		var PI = 3.1415926535897932384626;
		var a = 6378245.0;
		var ee = 0.00669342162296594323;
		
	    var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
	    var x = bd_lon - 0.0065;
	    var y = bd_lat - 0.006;
	    var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
	    var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);
	    var gg_lng = z * Math.cos(theta);
	    var gg_lat = z * Math.sin(theta);
	    return [gg_lng, gg_lat]
	},
	gcj02tobd09: function(lng, lat) {
		var x_PI = 3.14159265358979324 * 3000.0 / 180.0;
		var PI = 3.1415926535897932384626;
		var a = 6378245.0;
		var ee = 0.00669342162296594323;
		
	    var z = Math.sqrt(lng * lng + lat * lat) + 0.00002 * Math.sin(lat * x_PI);
	    var theta = Math.atan2(lat, lng) + 0.000003 * Math.cos(lng * x_PI);
	    var bd_lng = z * Math.cos(theta) + 0.0065;
	    var bd_lat = z * Math.sin(theta) + 0.006;
	    return [bd_lng, bd_lat]
	}
}
